PLaSK library

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
plask::GeometryObjectLeaf< dim >::GradientMaterial Struct Reference

`#include <plask/geometry/leaf.hpp>`

Inheritance diagram for plask::GeometryObjectLeaf< dim >::GradientMaterial:
[legend]
Collaboration diagram for plask::GeometryObjectLeaf< dim >::GradientMaterial:
[legend]

## Public Member Functions
| GradientMaterial (shared_ptr< MaterialsDB::MixedCompositionFactory > materialFactory)
shared_ptr< Material > | getMaterial (const GeometryObjectLeaf< dim > &thisObj, const DVec &p) const override
shared_ptr< Material > | singleMaterial () const override
| Get material only if it this provider represents solid material (if getMaterial returns value independent from arguments).
GradientMaterial * | clone () const override
shared_ptr< Material > | getRepresentativeMaterial () const override
| Get representative material of this provider (typically material which is returned in center of object).
bool | isUniform (Primitive< 3 >::Direction direction) const override
XMLWriter::Element & | writeXML (XMLWriter::Element &dest_xml_object, const AxisNames &axes) const override
Public Member Functions inherited from plask::GeometryObjectLeaf< dim >::MaterialProvider
virtual | ~MaterialProvider ()

## Public Attributes
shared_ptr< MaterialsDB::MixedCompositionFactory > | materialFactory

## Detailed Description

template<int dim>
struct plask::GeometryObjectLeaf< dim >::GradientMaterial

Definition at line 90 of file leaf.hpp.

## Constructor & Destructor Documentation

## ◆ GradientMaterial()

template<int dim>

plask::GeometryObjectLeaf< dim >::GradientMaterial::GradientMaterial | ( | shared_ptr< MaterialsDB::MixedCompositionFactory > | materialFactory | ) |
| inline

Definition at line 93 of file leaf.hpp.

## Member Function Documentation

## ◆ clone()

template<int dim>

GradientMaterial * plask::GeometryObjectLeaf< dim >::GradientMaterial::clone | ( |  | ) | const
| inline override virtual

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 104 of file leaf.hpp.

## ◆ getMaterial()

template<int dim>

shared_ptr< Material > plask::GeometryObjectLeaf< dim >::GradientMaterial::getMaterial | ( | const GeometryObjectLeaf< dim > & | thisObj,
|  | const DVec & | p
| ) |  | const
| inline override virtual

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 96 of file leaf.hpp.

## ◆ getRepresentativeMaterial()

template<int dim>

shared_ptr< Material > plask::GeometryObjectLeaf< dim >::GradientMaterial::getRepresentativeMaterial | ( |  | ) | const
| inline override virtual

Get representative material of this provider (typically material which is returned in center of object).

Returns
  representative material of this provider

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 106 of file leaf.hpp.

## ◆ isUniform()

template<int dim>

bool plask::GeometryObjectLeaf< dim >::GradientMaterial::isUniform | ( | Primitive< 3 >::Direction | direction | ) | const
| inline override virtual

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 108 of file leaf.hpp.

## ◆ singleMaterial()

template<int dim>

shared_ptr< Material > plask::GeometryObjectLeaf< dim >::GradientMaterial::singleMaterial | ( |  | ) | const
| inline override virtual

Get material only if it this provider represents solid material (if getMaterial returns value independent from arguments).

Returns
  material or nullptr if it is not solid

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 102 of file leaf.hpp.

## ◆ writeXML()

template<int dim>

XMLWriter::Element & plask::GeometryObjectLeaf< dim >::GradientMaterial::writeXML | ( | XMLWriter::Element & | dest_xml_object,
|  | const AxisNames & | axes
| ) |  | const
| override virtual

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 28 of file leaf.cpp.

## Member Data Documentation

## ◆ materialFactory

template<int dim>

shared_ptr<MaterialsDB::MixedCompositionFactory> plask::GeometryObjectLeaf< dim >::GradientMaterial::materialFactory

Definition at line 91 of file leaf.hpp.

The documentation for this struct was generated from the following files:

- plask/geometry/leaf.hpp
- plask/geometry/leaf.cpp